#pragma once

//#include "TrayPopup.h"
#include "DuiTrayPopup.h"
#include "afxwin.h" 
#include "afxcmn.h"     
#include "stdafx.h"
#include <io.h>

class CNeMessengerApp;
class CNeMessengerDlg;
class CMainDlg;
extern CNeMessengerDlg* g_pMain;
extern CNeMessengerDlg* GET_MESSENGER_DLG();


//GetAPP   ũ.
#define GET_APP()			((CNeMessengerApp*)AfxGetApp())
//Config Data   ũ.
#define GET_CONFIG()		(GET_APP()->m_pClientConfig)

typedef struct _TAG_STRUCT_BUDDY_COMPARE{
	CString  Name;
	int status;

	_TAG_STRUCT_BUDDY_COMPARE(CString name, int sts)
	{
		Name = name;
		status = sts;
	}
}STRUCT_BUDDY_COMPARE;



//Ʈ
extern CFont g_ftGulim6PT;
extern CFont g_ftGulim7PT;
extern CFont g_ftGulim8PT;
extern CFont g_ftGulim9PT;
extern CFont g_ftGulim10PT;
extern CFont g_ftDefault6PT;
extern CFont g_ftDefault7PT;
extern CFont g_ftDefault8PT;
extern CFont g_ftDefault9PT;
extern CFont g_ftDefault10PT;
extern CFont g_ftDefault11PT;
extern CFont g_ftDefault12PT;
extern CFont g_ftDefault13PT;
extern CFont g_ftDefault14PT;

extern CFont g_ftDefault9PTB;
extern CFont g_ftDefault10PTB;
extern CFont g_ftDefault11PTB;

extern CFont g_ftDefault8PX;
extern CFont g_ftDefault9PX;
extern CFont g_ftDefault10PX;
extern CFont g_ftDefault11PX;
extern CFont g_ftDefault12PX;
extern CFont g_ftDefault13PX;
extern CFont g_ftDefault14PX;

extern CFont g_ftDefault12PXB;
extern CFont g_ftDefault13PXB;
extern CFont g_ftDefault14PXB;
extern CFont g_ftDefault15PXB;


extern CFont g_ftDotum10PX;
extern CFont g_ftDotum11PX;
extern CFont g_ftDotum12PX;
extern CFont g_ftDotum13PX;

extern CFont g_ftDotum10PXB;
extern CFont g_ftDotum11PXB;
extern CFont g_ftDotum12PXB;
extern CFont g_ftDotum13PXB;

extern bool g_bFavoriteListDlgOpened;	// ȭ  ߰ ˾â µ ¿ ޽ â ׷ ߰,  Ұ

/**
*   @brief std ƼƮ string ڵ CString ȯѴ

*/

extern CString String2CString(std::string str);

int BuddyItemComareFunc(const STRUCT_BUDDY_COMPARE elem1, const STRUCT_BUDDY_COMPARE elem2);


/**
*   @brief Ǵ 츦 θ   ٷ ٿ Ѵ.
*   @param pWndParent  θ
*   @param pWndChild  ڽ
*   @param bLeftFirst TRUE  FALSE 
*   @return 
*/
extern void SetWindowPosToSide(CWnd * pWndParent, CWnd * pWndChild, bool bLeftFirst=true);

/**
*   @brief Ʈ д´
*   @param hKey 
*   @param lpKey
*   @param lpDefault 
*   @param lpRet 
*   @param nSize 
*   @return TRUE  
*/
extern BOOL reg_ReadString(HKEY hKey, TCHAR* lpKey,TCHAR* lpValue,TCHAR* lpDefault,TCHAR* lpRet,DWORD nSize);

/**
*   @brief Ʈ 
*   @param hKey 
*   @param lpKey
*   @param lpValue 
*   @param lpData 
*   @param bFlush 
*   @return TRUE 
*/
extern BOOL reg_WriteString(HKEY hKey,TCHAR* lpKey,TCHAR* lpValue, TCHAR* lpData, BOOL bFlush=TRUE);

/**
*   @brief Ʈ Ѵ
*   @param hKey 
*   @param lpKey
*   @param lpValue 
*   @return TRUE  
*/
extern BOOL reg_DeleteValue(HKEY hKey, TCHAR* lpKey, TCHAR* lpValue);



/**
*   @brief PTƮ Ѵ.
*   @param pszFaceName ü
*   @param nFontSize ũ
*   @param nFontSize β, FW_THIN, FW_NORMAL, FW_BOLD
*   @param bItalic ڸü  
*   @param bUnderline   
*   @return HFONT
*/
extern HFONT CreateSmartFont(LPCTSTR pszFaceName,int nFontSize,int nFontWeight=FW_NORMAL,BOOL bItalic=FALSE, BOOL bUnderline=FALSE, UINT nQuality=DEFAULT_QUALITY);



/**
*   @brief PXƮ Ѵ.
*   @param pszFaceName ü
*   @param nFontSize ũ
*   @param nFontSize β, FW_THIN, FW_NORMAL, FW_BOLD
*   @param bItalic ڸü  
*   @param bUnderline   
*   @return HFONT
*/
extern HFONT CreateSmartPixelFont(LPCTSTR pszFaceName,int nFontSize,int nFontWeight=FW_NORMAL,BOOL bItalic=FALSE, BOOL bUnderline=FALSE, UINT nQuality=DEFAULT_QUALITY);

/**
*   @brief ڿ ҽ ڿ 
*   @param nID ڿ ҽ ID
*   @return ҽ ڿ
*/
extern CString& GetResString(UINT nID);

/**
*   @brief Ư Pathκ ̹ ڵ ´.
*   @param pszPath
*   @return HBITMAP
*/
extern HBITMAP LoadImageFromPath(LPCTSTR pszPath);

/**
*  @fn extern char* UTF8ToANSI()
*  @brief     utf8 ansi ȯѴ.
*
*  @author	  yangjaepark 
*  @date      2012/02/10
*  @see
*  @exception none
*  @throw     none
*  @param     char * pszCode
*  @warning   
*  @bug
*  @todo
*/extern std::string UTF8ToANSI(char *pszCode);



/**
*  @fn extern std::wstring AnsiToUnicode()
*  @brief    ansi string ڵ wstring ȯ
*
*  @author	  yangjaepark 
*  @date      2012/02/01
*  @see
*  @exception none
*  @throw     none
*  @param     const std::string & s
*  @warning   
*  @bug
*  @todo
*/extern std::wstring AnsiToUnicode(const std::string& s);



/**
*  @fn extern CString UrlEncode()
*  @brief     URL ڵ Լ
*	ϰ URLڵ  ڿ ȯѴ.
*  @author	  yangjaepark 
*  @date      2012/02/18
*  @see
*  @exception none
*  @throw     none
*  @param     CString aSrc
*  @warning   ڿ  4,297,967,295̻ ڵ Ұϴ.
*  @bug
*  @todo
*/extern CString UrlEncode(CString aSrc);


/**
*   @brief Ư Pathκ ̹ ´.
*   @param bmpImage CBitmap Ʈ
*   @param pszPath
*   @return bool
*/
extern bool LoadBitmapFromPath(CBitmap& bmpImage,LPCTSTR pszPath);

extern CString GetDefaultFontFaceName();
extern WCHAR* GetDefaultFontFaceNameW();
extern int    GetDefaultFontIndex();    //refactor for ChatDlg::RefreshTitle

extern WCHAR* g_defaultFontFaceName;

extern void ChangeToWorkingDirectory( CString &strPath );
extern void SetWorkingDirectory(LPCTSTR pszWorkingPath);
extern CString GetWorkingDirectory();
extern CString GetLanguageStringUnicode();
extern const std::string GetLanguageString();
extern bool MultiplyAlpha(CImage& image);
extern bool GetIndexBitmapFromImage(CBitmap& bmpSlice,CBitmap& bmpTotalImage,int nIndex,int nSliceCount);
extern HRESULT ExplorerToSpecialFile(const CString& strFilePath);

extern unsigned char *base64_encode(unsigned char *str, int length, int *ret_length);
extern unsigned char *base64_decode(unsigned char *str, int *ret_length);
extern int EncryptSIP(IN LPCTSTR strID, IN char* szPlainMsg, OUT unsigned char* byteEncryptedMsg);
extern void DecryptSIP(IN LPCTSTR strID, IN unsigned char* byteEncMsg, IN int nEncSize, OUT char* szPlainMsg);
extern CString GetHddSerial();
extern CString LoadStringFromResource(UINT nID);


/**
*  @fn extern void Trace()
*  @brief      尡 Ұ Ͽ TRACE ؼ  
* 
*  @author	  yangjaepark 
*  @date      2012/02/18
*  @see
*  @exception none
*  @throw     none
*  @param     TCHAR * szFormat
*  @param     ...
*  @warning   
*  @bug
*  @todo
*/extern void Trace(TCHAR* szFormat,...);

#define SHCU						HKEY_CURRENT_USER
#define SHLM						HKEY_LOCAL_MACHINE
#define SHRT						HKEY_CLASSES_ROOT


//chat msg alarm pop : Dui window.
#define TRAYPOPUP_CHAT(nDrawType, infoTrayPop,/*pszMessage,*/ pParent, nNotifyMessage, wParam)	CDuiTrayPopup::ChatShow(nDrawType , MAIN_CAPTION_NAME, infoTrayPop, 6, pParent, nNotifyMessage, wParam)

#define TRAYPOPUP(nDrawType, pszUserID, pszMessage, pParent, nNotifyMessage, wParam)	CDuiTrayPopup::Show(nDrawType , pszUserID, MAIN_CAPTION_NAME, pszMessage, 6, pParent, nNotifyMessage, wParam)



#define TRAYPOPUP_IPT(nDrawType, pszUsrID, pszName, pszExt, pszPostion, pszJob, pszPart, pParent, nNotifyMessage, wParam) CDuiTrayPopup::IPTShow(nDrawType,pszUsrID, pszName, pszExt, pszPostion, pszJob, pszPart, 10, pParent, nNotifyMessage, wParam)



#define KILLTRAYPOPUP(wParam)     CDuiTrayPopup::Kill(wParam)
	                             
#define KILLALLTRAYPOPUP()        CDuiTrayPopup::KillAll()
                                 
                     
#define KILLALLIPTTTRAYPOPUP()	   CDuiTrayPopup::KillAllIPT()
	                              





#define DDX_CHECKBOX_VALUE(check,variable,ctrl_to_value)    \
{                                                   		\
	if(ctrl_to_value)                               		\
	{                                               		\
		if(check.GetCheck()==BST_CHECKED)					\
			variable=1;										\
		else                                        		\
			variable=0;										\
	}                                               		\
	else                                            		\
	{                                               		\
		if(variable)										\
			check.SetCheck(BST_CHECKED);					\
		else                                        		\
			check.SetCheck(BST_UNCHECKED);					\
	}                                               		\
}                                                   		\

extern CBitmap m_bmpContentTop[3];
extern CBitmap m_bmpContentMiddle[2];
extern CBitmap m_bmpContentBottom[3];
extern void GetContentBG(CBitmap& bmpBG, LPRECT lpRectContent, CDC* pDC);



extern std::string UriEncode(const std::string & sSrc);



// ؿ 2 Լ ClientConfig ̵.
//ۼ  Բ ּû
//
/**
*  @fn extern char* StringToChar()
*  @brief     
*
*  @author	   
*  @date      2012/02/18
*  @see
*  @exception none
*  @throw     none
*  @param     CString str
*  @warning   
*  @bug
*  @todo
*/extern char* StringToChar(CString str);
/**
*  @fn extern CString CharToString()
*  @brief     
*
*  @author	   
*  @date      2012/02/18
*  @see
*  @exception none
*  @throw     none
*  @param     char * str
*  @warning   
*  @bug
*  @todo
*/extern CString CharToString(char *str);
//

extern size_t Split(const CString& text, const CString& delimiter, bool bWithDelimeter, std::vector<CString>& tokens);


extern std::string UnicodeToUTF8(CString strUnicode);
extern CString UTF8ToUnicode(const char *utf8_string, int length);



extern std::string UnicodeToURIEncode(const CString &strUnicode);
/*!
*  @fn extern int GetLocaleTime()
*  @brief     ȯ漳 m_nGMT Ctime · ȯѴ.
*  @return    
*  @param     CTime * t
*  @author	  yangjae.park(yangjae.park@nhn.com) 
*  @date      2012/02/27
*  @warning   
*/extern int GetLocaleTime(CTime* t);

/*
*  @fn extern int GetGMTTime()
*/
extern int GetGMTTime(CTime* t);

/*!
*  @fn extern CTime StringToCTime()
*  @brief     CString 2008-11-12 14:54:00 ¸ Ctime ȯ
*  @return    
*  @param     CString strTime
*  @author	  yangjae.park(yangjae.park@nhn.com) 
*  @date      2012/02/27
*  @warning   
*/extern CTime StringToCTime(CString strTime);

/*!
*  @fn extern CString CTimeToCString()
*  @brief     CTime 2008-11-12 14:54:00  CString ȯ
*  @return    
*  @param     CTime ct
*  @author	  yangjae.park(yangjae.park@nhn.com) 
*  @date      2012/02/27
*  @warning   
*/extern CString CTimeToCString(CTime ct);

/*!
*  @fn extern int CTimeToInt()
*  @brief     
*  @return    
*  @param     CTime ct
*  @author	  Jao.Zhang(zhangyi19860913@nhn.com) 
*  @date      2013/06/18
*  @warning   
*/extern INT64 CTimeToInt(const CTime& ct);

  
/*!
*  @fn extern CString LocalTimeConvert()
*  @brief     
*  @return    
*  @param     CString strTime
*  @author	  yangjae.park(yangjae.park@nhn.com) 
*  @date      2012/02/27
*  @warning   
*/extern CString LocalTimeConvert(CString strTime);

extern int SplitString(LPCTSTR pszSrc, TCHAR split, vector<CString> &rvec);
extern int SplitString_NotEmpty(LPCTSTR pszSrc, TCHAR split, vector<CString> &rvec);



/*!
*  @fn extern const CString GetProductVersion()
*  @brief       ´.
*  @return     .
*  @author	  yangjae.park(yangjae.park@nhn.com) 
*  @date      2012/03/30
*/extern const CString GetProductVersion();


/*!
*  @fn extern BOOL UtilFillSolidRect()
*  @brief     CDC FillsolidRect ε ϴ. hdc ٷ   .
*  @return    
*  @param     HDC hdc
*  @param     const RECT * rc
*  @param     COLORREF color
*  @author	  yangjae.park(yangjae.park@nhn.com) 
*  @date      2012/04/03
*/extern BOOL UtilFillSolidRect(HDC hdc,const RECT *rc,COLORREF color);



extern BOOL CreateDirectoryTree(LPCTSTR lptzPath);



extern BOOL RegisterWindowClass(const TCHAR* pszClassName);

extern CString GetNtalkModulePath();
extern CString GetAppImgDir();
extern CString GetMyDocNtalkDir();
extern CString GetAppDataNtalkDir();
extern void DeleteDirectory(CString strDir);
extern CString GetAppMemoDir();
extern CString GetAppImgFile(CString strFileName);
extern CString GetSmartEditorDir();
extern CString InsertCharToString(CString strOrigin, int nPos, TCHAR ch);
extern BOOL DrawImageToDest(Graphics* pGraph, Image* pImg, CRect* pRtPS, CRect* pRtImg, ImageAttributes* pImgAttr);
extern BOOL DrawImageToDest(Graphics* pGraph, Image* pImg, CRect* pRtPS, CRect* pRtImg, CRect* pRtSrc, ImageAttributes* pImgAttr);
extern void DrawImageToStretchHorz(Graphics* pGraph, Image* pImg, CRect* pRtPS, CRect* pRtImg, Color crVert, ImageAttributes* pImgAttr);
extern void DrawImageToStretchHorzExceptL(Graphics* pGraph, Image* pImg, CRect* pRtPS, CRect* pRtImg, int nPixel, ImageAttributes* pImgAttr);
extern void DrawTextToDest(Graphics* pGraph,
					CString strText, CRect* pRtPS, CRect* pRtText,
					int nSX, int nSY,
					WCHAR* wszFontName, int nFontHeight,
					Gdiplus::StringAlignment alignment, Gdiplus::FontStyle style,
					Color crPen, int nPenWidth,
					BOOL bGradient,
					Color crFill1, Color crFill2);
extern void DrawTextToDest2(Graphics* pGraph,
					 CString strText, CRect* pRtPS, CRect* pRtText,
					 WCHAR* wszFontName, REAL nFontHeight,
					 Gdiplus::StringAlignment alignment, Gdiplus::FontStyle style,
					 Color crPen, StringFormatFlags strFormatFlags = StringFormatFlags(0));
extern void RecalcTextRect(CWnd* pWnd, CString strText, WCHAR* wszFontName, REAL& nFontHeight, Gdiplus::FontStyle style, CRect rtBound, CSize& szBound);
extern void RecalcTextRectVert(CWnd* pWnd, CString strText, WCHAR* wszFontName, REAL nFontHeight, Gdiplus::FontStyle style, CRect rtBound, CSize& szBound, BOOL bWrap = TRUE);
extern void RecalcTextRectVert2(CWnd* pWnd, CString strText, WCHAR* wszFontName, REAL nFontHeight, Gdiplus::FontStyle style, CRect rtBound, CSize& szBound);
extern void RecalcTextRect2(CWnd* pWnd, CString strText, WCHAR* wszFontName, int& nFontHeight, int nThickness, CRect rtBound, CSize& szBound);
extern int RecalcTextRect3(CWnd* pWnd, CString strText, WCHAR* wszFontName, REAL& nFontHeight, Gdiplus::FontStyle style, CRect rtBound, CSize& szBound);

extern HBITMAP LoadPngToBmp(CString strPath, COLORREF colorTranslate = RGB(255, 0, 255));
extern CString RecalcTextString(CWnd* pWnd, CString strText, WCHAR* wszFontName, REAL nFontHeight, Gdiplus::FontStyle style, CRect rtBound);
extern BOOL MeasureGraphicsPath(Graphics* pGraphics, GraphicsPath* pGraphicsPath, float* pfPixelsWidth, float* pfPixelsHeight);
extern BOOL ConvertToPixels(Graphics* pGraphics, float fSrcWidth, float fSrcHeight, float* pfDestWidth, float* pfDestHeight);
extern HRGN BitmapToRegion(HBITMAP hBmp, COLORREF cTransparentColor, COLORREF cTolerance);
extern GraphicsPath* MakeRoundRect(Point topLeft, Point bottomRight, int nOffsetX, int nOffsetY);
extern int GetStringCount(CString& strString, TCHAR chParse, CStringArray* pAr);
extern VOID DrawIntervalMessageText(CDC* pDC, const CString& strText, const CRect& rcText, UINT nFormat, int yTextInterVal);
extern BOOL DrawNineBlockImage(Gdiplus::Graphics* pGraphics, Gdiplus::Image* pImages[9], const Gdiplus::RectF* pRect);

extern CString GetPresenceTip(int type);
CString GetIPTPresenceTip( NTIPTStatusType iptStatus );
extern bool ShowTooltip(HWND parent, CString strMsg);
extern void RelayTooTipEvent(HWND parent, LPMSG pMsg);
extern bool  HideTooltip(HWND parent, bool bDestroyWnd = false);

extern CString GetAppDUIImgDir();

#define LOGFILENAME "Timer.txt"
void  LogFile(LPCTSTR lpszFormat, ...);

namespace CodecConversion
{
	const std::string URLdecode(const std::string& l);

}


namespace Conversion
{
	const std::string WideToUtf8(const std::wstring& wideString);
	//const std::string WideToAcp(const std::wstring& wideString);
	const std::wstring Utf8ToWide(const std::string& utf8String);
	//const std::wstring AcpToWide(const std::string& utf8String);
}

namespace InputMethod
{
	void SetDefaultInputMethod(HWND hwnd);
}
namespace CTimeConversion
{
	CString GetStringDayOfWeek( CTime &startTime);
	const CTime GetKoreaTime();
}

class CCommonFunction
{
public:
	CCommonFunction(void);
	~CCommonFunction(void);

	static BOOL GetNetworkStatus();
};

class CColorConvert
{
public:
	static Color HEX2Color(UINT hex);
	static UINT Color2HEX(Color color);
};


